import sys
sys.path.append("../")
sys.path.append("../../")
from ffc.compiler.compiler import *

name = "Elasticity"

a = None
L = None
    
dx = Integral("interior")
ds = Integral("boundary")

i = Index()
j = Index()
k = Index()
l = Index()
m = Index()
n = Index()

# Copyright (c) 2005 Johan Jansson.
# Licensed under the GNU GPL Version 2
#
# The bilinear form e(u) : e(u) for linear
# elasticity with e(u) = grad(u) + grad(u)^T
#
# Compile this form with FFC: ffc Elasticity.form

element = FiniteElement("Vector Lagrange", "tetrahedron", 1)

v = BasisFunction(element)
u = BasisFunction(element)

a = (u[i].dx(j) + u[j].dx(i)) * (v[i].dx(j) + v[j].dx(i)) * dx

compile([a, L], name, "0.1.8", "C++", "GNU GPL Version 2")
