import sys
sys.path.append("../")
sys.path.append("../../")
from ffc.compiler.compiler import *

name = "Heat"

a = None
L = None
    
dx = Integral("interior")
ds = Integral("boundary")

i = Index()
j = Index()
k = Index()
l = Index()
m = Index()
n = Index()

# Copyright (c) 2005 Anders Logg (logg@tti-c.org)
# Licensed under the GNU GPL Version 2
#
# The bilinear form a(u,v) and linear form L(v) for
# one backward Euler step with the heat equation.
#
# Compile this form with FFC: ffc Heat.form

element = FiniteElement("Lagrange", "triangle", 1)

v  = BasisFunction(element) # Test function
u1 = BasisFunction(element) # Value at t_n
u0 = Function(element)      # Value at t_n-1
f  = Function(element)      # Heat source
k  = Constant()             # Time step (constant)

a = u1*v*dx + k*u1.dx(i)*v.dx(i)*dx
L = u0*v*dx + k*f*v*dx

compile([a, L], name, "0.1.8", "C++", "GNU GPL Version 2")
