// Automatically generated by FFC, the FEniCS Form Compiler, version 0.1.8.
// For further information, go to http://www/fenics.org/ffc/.
// Licensed under the GNU GPL Version 2.

#ifndef __../DEMO/NAVIERSTOKES_H
#define __../DEMO/NAVIERSTOKES_H

#include <dolfin/FiniteElement.h>
#include <dolfin/LinearForm.h>
#include <dolfin/BilinearForm.h>

namespace dolfin { namespace ../demo/NavierStokes {

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class BilinearForm : public dolfin::BilinearForm
{
public:
    
  class TestElement : public dolfin::FiniteElement
  {
  public:

    TestElement() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 12;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
      int offset = mesh.noNodes();
      dofs[4] = offset + cell.nodeID(0);
      dofs[5] = offset + cell.nodeID(1);
      dofs[6] = offset + cell.nodeID(2);
      dofs[7] = offset + cell.nodeID(3);
      offset = offset + mesh.noNodes();
      dofs[8] = offset + cell.nodeID(0);
      dofs[9] = offset + cell.nodeID(1);
      dofs[10] = offset + cell.nodeID(2);
      dofs[11] = offset + cell.nodeID(3);
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[5] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[9] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[10] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 1;
      components[5] = 1;
      components[6] = 1;
      components[7] = 1;
      components[8] = 2;
      components[9] = 2;
      components[10] = 2;
      components[11] = 2;
    }

  private:

    unsigned int* tensordims;

  };
    
  class TrialElement : public dolfin::FiniteElement
  {
  public:

    TrialElement() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~TrialElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 12;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
      int offset = mesh.noNodes();
      dofs[4] = offset + cell.nodeID(0);
      dofs[5] = offset + cell.nodeID(1);
      dofs[6] = offset + cell.nodeID(2);
      dofs[7] = offset + cell.nodeID(3);
      offset = offset + mesh.noNodes();
      dofs[8] = offset + cell.nodeID(0);
      dofs[9] = offset + cell.nodeID(1);
      dofs[10] = offset + cell.nodeID(2);
      dofs[11] = offset + cell.nodeID(3);
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[5] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[9] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[10] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 1;
      components[5] = 1;
      components[6] = 1;
      components[7] = 1;
      components[8] = 2;
      components[9] = 2;
      components[10] = 2;
      components[11] = 2;
    }

  private:

    unsigned int* tensordims;

  };
    
  class FunctionElement_0 : public dolfin::FiniteElement
  {
  public:

    FunctionElement_0() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~FunctionElement_0()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 12;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
      int offset = mesh.noNodes();
      dofs[4] = offset + cell.nodeID(0);
      dofs[5] = offset + cell.nodeID(1);
      dofs[6] = offset + cell.nodeID(2);
      dofs[7] = offset + cell.nodeID(3);
      offset = offset + mesh.noNodes();
      dofs[8] = offset + cell.nodeID(0);
      dofs[9] = offset + cell.nodeID(1);
      dofs[10] = offset + cell.nodeID(2);
      dofs[11] = offset + cell.nodeID(3);
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[5] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[9] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[10] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 1;
      components[5] = 1;
      components[6] = 1;
      components[7] = 1;
      components[8] = 2;
      components[9] = 2;
      components[10] = 2;
      components[11] = 2;
    }

  private:

    unsigned int* tensordims;

  };

  BilinearForm(Function& w0) : dolfin::BilinearForm(1)
  {
    // Create finite element for test space
    _test = new TestElement();

    // Create finite element for trial space
    _trial = new TrialElement();
        
    // Add functions
    add(w0, new FunctionElement_0());
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute geometry tensors
    real G0_0_0_0 = map.det*c[0][0]*map.g00;
    real G0_0_0_1 = map.det*c[0][0]*map.g10;
    real G0_0_0_2 = map.det*c[0][0]*map.g20;
    real G0_0_1_0 = map.det*c[0][1]*map.g00;
    real G0_0_1_1 = map.det*c[0][1]*map.g10;
    real G0_0_1_2 = map.det*c[0][1]*map.g20;
    real G0_0_2_0 = map.det*c[0][2]*map.g00;
    real G0_0_2_1 = map.det*c[0][2]*map.g10;
    real G0_0_2_2 = map.det*c[0][2]*map.g20;
    real G0_0_3_0 = map.det*c[0][3]*map.g00;
    real G0_0_3_1 = map.det*c[0][3]*map.g10;
    real G0_0_3_2 = map.det*c[0][3]*map.g20;
    real G0_1_4_0 = map.det*c[0][4]*map.g01;
    real G0_1_4_1 = map.det*c[0][4]*map.g11;
    real G0_1_4_2 = map.det*c[0][4]*map.g21;
    real G0_1_5_0 = map.det*c[0][5]*map.g01;
    real G0_1_5_1 = map.det*c[0][5]*map.g11;
    real G0_1_5_2 = map.det*c[0][5]*map.g21;
    real G0_1_6_0 = map.det*c[0][6]*map.g01;
    real G0_1_6_1 = map.det*c[0][6]*map.g11;
    real G0_1_6_2 = map.det*c[0][6]*map.g21;
    real G0_1_7_0 = map.det*c[0][7]*map.g01;
    real G0_1_7_1 = map.det*c[0][7]*map.g11;
    real G0_1_7_2 = map.det*c[0][7]*map.g21;
    real G0_2_8_0 = map.det*c[0][8]*map.g02;
    real G0_2_8_1 = map.det*c[0][8]*map.g12;
    real G0_2_8_2 = map.det*c[0][8]*map.g22;
    real G0_2_9_0 = map.det*c[0][9]*map.g02;
    real G0_2_9_1 = map.det*c[0][9]*map.g12;
    real G0_2_9_2 = map.det*c[0][9]*map.g22;
    real G0_2_10_0 = map.det*c[0][10]*map.g02;
    real G0_2_10_1 = map.det*c[0][10]*map.g12;
    real G0_2_10_2 = map.det*c[0][10]*map.g22;
    real G0_2_11_0 = map.det*c[0][11]*map.g02;
    real G0_2_11_1 = map.det*c[0][11]*map.g12;
    real G0_2_11_2 = map.det*c[0][11]*map.g22;

    // Compute element tensor
    block[0] = -1.666666666666662e-02*G0_0_0_0 - 1.666666666666662e-02*G0_0_0_1 - 1.666666666666662e-02*G0_0_0_2 - 8.333333333333309e-03*G0_0_1_0 - 8.333333333333309e-03*G0_0_1_1 - 8.333333333333309e-03*G0_0_1_2 - 8.333333333333307e-03*G0_0_2_0 - 8.333333333333307e-03*G0_0_2_1 - 8.333333333333307e-03*G0_0_2_2 - 8.333333333333311e-03*G0_0_3_0 - 8.333333333333311e-03*G0_0_3_1 - 8.333333333333311e-03*G0_0_3_2 - 1.666666666666662e-02*G0_1_4_0 - 1.666666666666662e-02*G0_1_4_1 - 1.666666666666662e-02*G0_1_4_2 - 8.333333333333309e-03*G0_1_5_0 - 8.333333333333309e-03*G0_1_5_1 - 8.333333333333309e-03*G0_1_5_2 - 8.333333333333312e-03*G0_1_6_0 - 8.333333333333312e-03*G0_1_6_1 - 8.333333333333311e-03*G0_1_6_2 - 8.333333333333311e-03*G0_1_7_0 - 8.333333333333311e-03*G0_1_7_1 - 8.333333333333311e-03*G0_1_7_2 - 1.666666666666662e-02*G0_2_8_0 - 1.666666666666662e-02*G0_2_8_1 - 1.666666666666662e-02*G0_2_8_2 - 8.333333333333309e-03*G0_2_9_0 - 8.333333333333309e-03*G0_2_9_1 - 8.333333333333309e-03*G0_2_9_2 - 8.333333333333312e-03*G0_2_10_0 - 8.333333333333312e-03*G0_2_10_1 - 8.333333333333311e-03*G0_2_10_2 - 8.333333333333311e-03*G0_2_11_0 - 8.333333333333311e-03*G0_2_11_1 - 8.333333333333311e-03*G0_2_11_2;
    block[1] = 1.666666666666662e-02*G0_0_0_0 + 8.333333333333309e-03*G0_0_1_0 + 8.333333333333307e-03*G0_0_2_0 + 8.333333333333311e-03*G0_0_3_0 + 1.666666666666662e-02*G0_1_4_0 + 8.333333333333309e-03*G0_1_5_0 + 8.333333333333312e-03*G0_1_6_0 + 8.333333333333311e-03*G0_1_7_0 + 1.666666666666662e-02*G0_2_8_0 + 8.333333333333309e-03*G0_2_9_0 + 8.333333333333312e-03*G0_2_10_0 + 8.333333333333311e-03*G0_2_11_0;
    block[2] = 1.666666666666662e-02*G0_0_0_1 + 8.333333333333309e-03*G0_0_1_1 + 8.333333333333307e-03*G0_0_2_1 + 8.333333333333311e-03*G0_0_3_1 + 1.666666666666662e-02*G0_1_4_1 + 8.333333333333309e-03*G0_1_5_1 + 8.333333333333312e-03*G0_1_6_1 + 8.333333333333311e-03*G0_1_7_1 + 1.666666666666662e-02*G0_2_8_1 + 8.333333333333309e-03*G0_2_9_1 + 8.333333333333312e-03*G0_2_10_1 + 8.333333333333311e-03*G0_2_11_1;
    block[3] = 1.666666666666662e-02*G0_0_0_2 + 8.333333333333309e-03*G0_0_1_2 + 8.333333333333307e-03*G0_0_2_2 + 8.333333333333311e-03*G0_0_3_2 + 1.666666666666662e-02*G0_1_4_2 + 8.333333333333309e-03*G0_1_5_2 + 8.333333333333312e-03*G0_1_6_2 + 8.333333333333311e-03*G0_1_7_2 + 1.666666666666662e-02*G0_2_8_2 + 8.333333333333309e-03*G0_2_9_2 + 8.333333333333312e-03*G0_2_10_2 + 8.333333333333311e-03*G0_2_11_2;
    block[4] = 0.000000000000000e+00;
    block[5] = 0.000000000000000e+00;
    block[6] = 0.000000000000000e+00;
    block[7] = 0.000000000000000e+00;
    block[8] = 0.000000000000000e+00;
    block[9] = 0.000000000000000e+00;
    block[10] = 0.000000000000000e+00;
    block[11] = 0.000000000000000e+00;
    block[12] = -8.333333333333309e-03*G0_0_0_0 - 8.333333333333309e-03*G0_0_0_1 - 8.333333333333309e-03*G0_0_0_2 - 1.666666666666661e-02*G0_0_1_0 - 1.666666666666661e-02*G0_0_1_1 - 1.666666666666661e-02*G0_0_1_2 - 8.333333333333309e-03*G0_0_2_0 - 8.333333333333309e-03*G0_0_2_1 - 8.333333333333305e-03*G0_0_2_2 - 8.333333333333307e-03*G0_0_3_0 - 8.333333333333307e-03*G0_0_3_1 - 8.333333333333307e-03*G0_0_3_2 - 8.333333333333305e-03*G0_1_4_0 - 8.333333333333305e-03*G0_1_4_1 - 8.333333333333305e-03*G0_1_4_2 - 1.666666666666661e-02*G0_1_5_0 - 1.666666666666661e-02*G0_1_5_1 - 1.666666666666661e-02*G0_1_5_2 - 8.333333333333309e-03*G0_1_6_0 - 8.333333333333309e-03*G0_1_6_1 - 8.333333333333307e-03*G0_1_6_2 - 8.333333333333307e-03*G0_1_7_0 - 8.333333333333307e-03*G0_1_7_1 - 8.333333333333307e-03*G0_1_7_2 - 8.333333333333305e-03*G0_2_8_0 - 8.333333333333305e-03*G0_2_8_1 - 8.333333333333305e-03*G0_2_8_2 - 1.666666666666661e-02*G0_2_9_0 - 1.666666666666661e-02*G0_2_9_1 - 1.666666666666661e-02*G0_2_9_2 - 8.333333333333309e-03*G0_2_10_0 - 8.333333333333309e-03*G0_2_10_1 - 8.333333333333307e-03*G0_2_10_2 - 8.333333333333307e-03*G0_2_11_0 - 8.333333333333307e-03*G0_2_11_1 - 8.333333333333307e-03*G0_2_11_2;
    block[13] = 8.333333333333309e-03*G0_0_0_0 + 1.666666666666661e-02*G0_0_1_0 + 8.333333333333309e-03*G0_0_2_0 + 8.333333333333307e-03*G0_0_3_0 + 8.333333333333305e-03*G0_1_4_0 + 1.666666666666661e-02*G0_1_5_0 + 8.333333333333309e-03*G0_1_6_0 + 8.333333333333307e-03*G0_1_7_0 + 8.333333333333305e-03*G0_2_8_0 + 1.666666666666661e-02*G0_2_9_0 + 8.333333333333309e-03*G0_2_10_0 + 8.333333333333307e-03*G0_2_11_0;
    block[14] = 8.333333333333309e-03*G0_0_0_1 + 1.666666666666661e-02*G0_0_1_1 + 8.333333333333309e-03*G0_0_2_1 + 8.333333333333307e-03*G0_0_3_1 + 8.333333333333305e-03*G0_1_4_1 + 1.666666666666661e-02*G0_1_5_1 + 8.333333333333309e-03*G0_1_6_1 + 8.333333333333307e-03*G0_1_7_1 + 8.333333333333305e-03*G0_2_8_1 + 1.666666666666661e-02*G0_2_9_1 + 8.333333333333309e-03*G0_2_10_1 + 8.333333333333307e-03*G0_2_11_1;
    block[15] = 8.333333333333309e-03*G0_0_0_2 + 1.666666666666661e-02*G0_0_1_2 + 8.333333333333309e-03*G0_0_2_2 + 8.333333333333307e-03*G0_0_3_2 + 8.333333333333305e-03*G0_1_4_2 + 1.666666666666661e-02*G0_1_5_2 + 8.333333333333309e-03*G0_1_6_2 + 8.333333333333307e-03*G0_1_7_2 + 8.333333333333305e-03*G0_2_8_2 + 1.666666666666661e-02*G0_2_9_2 + 8.333333333333309e-03*G0_2_10_2 + 8.333333333333307e-03*G0_2_11_2;
    block[16] = 0.000000000000000e+00;
    block[17] = 0.000000000000000e+00;
    block[18] = 0.000000000000000e+00;
    block[19] = 0.000000000000000e+00;
    block[20] = 0.000000000000000e+00;
    block[21] = 0.000000000000000e+00;
    block[22] = 0.000000000000000e+00;
    block[23] = 0.000000000000000e+00;
    block[24] = -8.333333333333309e-03*G0_0_0_0 - 8.333333333333309e-03*G0_0_0_1 - 8.333333333333305e-03*G0_0_0_2 - 8.333333333333307e-03*G0_0_1_0 - 8.333333333333307e-03*G0_0_1_1 - 8.333333333333305e-03*G0_0_1_2 - 1.666666666666661e-02*G0_0_2_0 - 1.666666666666661e-02*G0_0_2_1 - 1.666666666666661e-02*G0_0_2_2 - 8.333333333333311e-03*G0_0_3_0 - 8.333333333333311e-03*G0_0_3_1 - 8.333333333333309e-03*G0_0_3_2 - 8.333333333333305e-03*G0_1_4_0 - 8.333333333333305e-03*G0_1_4_1 - 8.333333333333304e-03*G0_1_4_2 - 8.333333333333309e-03*G0_1_5_0 - 8.333333333333309e-03*G0_1_5_1 - 8.333333333333309e-03*G0_1_5_2 - 1.666666666666662e-02*G0_1_6_0 - 1.666666666666662e-02*G0_1_6_1 - 1.666666666666661e-02*G0_1_6_2 - 8.333333333333311e-03*G0_1_7_0 - 8.333333333333311e-03*G0_1_7_1 - 8.333333333333309e-03*G0_1_7_2 - 8.333333333333305e-03*G0_2_8_0 - 8.333333333333305e-03*G0_2_8_1 - 8.333333333333304e-03*G0_2_8_2 - 8.333333333333309e-03*G0_2_9_0 - 8.333333333333309e-03*G0_2_9_1 - 8.333333333333309e-03*G0_2_9_2 - 1.666666666666662e-02*G0_2_10_0 - 1.666666666666662e-02*G0_2_10_1 - 1.666666666666661e-02*G0_2_10_2 - 8.333333333333311e-03*G0_2_11_0 - 8.333333333333311e-03*G0_2_11_1 - 8.333333333333309e-03*G0_2_11_2;
    block[25] = 8.333333333333309e-03*G0_0_0_0 + 8.333333333333307e-03*G0_0_1_0 + 1.666666666666661e-02*G0_0_2_0 + 8.333333333333311e-03*G0_0_3_0 + 8.333333333333305e-03*G0_1_4_0 + 8.333333333333309e-03*G0_1_5_0 + 1.666666666666662e-02*G0_1_6_0 + 8.333333333333311e-03*G0_1_7_0 + 8.333333333333305e-03*G0_2_8_0 + 8.333333333333309e-03*G0_2_9_0 + 1.666666666666662e-02*G0_2_10_0 + 8.333333333333311e-03*G0_2_11_0;
    block[26] = 8.333333333333309e-03*G0_0_0_1 + 8.333333333333307e-03*G0_0_1_1 + 1.666666666666661e-02*G0_0_2_1 + 8.333333333333311e-03*G0_0_3_1 + 8.333333333333305e-03*G0_1_4_1 + 8.333333333333309e-03*G0_1_5_1 + 1.666666666666662e-02*G0_1_6_1 + 8.333333333333311e-03*G0_1_7_1 + 8.333333333333305e-03*G0_2_8_1 + 8.333333333333309e-03*G0_2_9_1 + 1.666666666666662e-02*G0_2_10_1 + 8.333333333333311e-03*G0_2_11_1;
    block[27] = 8.333333333333309e-03*G0_0_0_2 + 8.333333333333307e-03*G0_0_1_2 + 1.666666666666661e-02*G0_0_2_2 + 8.333333333333311e-03*G0_0_3_2 + 8.333333333333305e-03*G0_1_4_2 + 8.333333333333309e-03*G0_1_5_2 + 1.666666666666662e-02*G0_1_6_2 + 8.333333333333311e-03*G0_1_7_2 + 8.333333333333305e-03*G0_2_8_2 + 8.333333333333309e-03*G0_2_9_2 + 1.666666666666662e-02*G0_2_10_2 + 8.333333333333311e-03*G0_2_11_2;
    block[28] = 0.000000000000000e+00;
    block[29] = 0.000000000000000e+00;
    block[30] = 0.000000000000000e+00;
    block[31] = 0.000000000000000e+00;
    block[32] = 0.000000000000000e+00;
    block[33] = 0.000000000000000e+00;
    block[34] = 0.000000000000000e+00;
    block[35] = 0.000000000000000e+00;
    block[36] = -8.333333333333311e-03*G0_0_0_0 - 8.333333333333311e-03*G0_0_0_1 - 8.333333333333311e-03*G0_0_0_2 - 8.333333333333307e-03*G0_0_1_0 - 8.333333333333307e-03*G0_0_1_1 - 8.333333333333307e-03*G0_0_1_2 - 8.333333333333311e-03*G0_0_2_0 - 8.333333333333311e-03*G0_0_2_1 - 8.333333333333309e-03*G0_0_2_2 - 1.666666666666662e-02*G0_0_3_0 - 1.666666666666662e-02*G0_0_3_1 - 1.666666666666662e-02*G0_0_3_2 - 8.333333333333305e-03*G0_1_4_0 - 8.333333333333305e-03*G0_1_4_1 - 8.333333333333305e-03*G0_1_4_2 - 8.333333333333311e-03*G0_1_5_0 - 8.333333333333311e-03*G0_1_5_1 - 8.333333333333309e-03*G0_1_5_2 - 8.333333333333314e-03*G0_1_6_0 - 8.333333333333314e-03*G0_1_6_1 - 8.333333333333312e-03*G0_1_6_2 - 1.666666666666662e-02*G0_1_7_0 - 1.666666666666662e-02*G0_1_7_1 - 1.666666666666662e-02*G0_1_7_2 - 8.333333333333305e-03*G0_2_8_0 - 8.333333333333305e-03*G0_2_8_1 - 8.333333333333305e-03*G0_2_8_2 - 8.333333333333311e-03*G0_2_9_0 - 8.333333333333311e-03*G0_2_9_1 - 8.333333333333309e-03*G0_2_9_2 - 8.333333333333312e-03*G0_2_10_0 - 8.333333333333312e-03*G0_2_10_1 - 8.333333333333311e-03*G0_2_10_2 - 1.666666666666662e-02*G0_2_11_0 - 1.666666666666662e-02*G0_2_11_1 - 1.666666666666662e-02*G0_2_11_2;
    block[37] = 8.333333333333311e-03*G0_0_0_0 + 8.333333333333307e-03*G0_0_1_0 + 8.333333333333311e-03*G0_0_2_0 + 1.666666666666662e-02*G0_0_3_0 + 8.333333333333305e-03*G0_1_4_0 + 8.333333333333311e-03*G0_1_5_0 + 8.333333333333314e-03*G0_1_6_0 + 1.666666666666662e-02*G0_1_7_0 + 8.333333333333305e-03*G0_2_8_0 + 8.333333333333311e-03*G0_2_9_0 + 8.333333333333312e-03*G0_2_10_0 + 1.666666666666662e-02*G0_2_11_0;
    block[38] = 8.333333333333311e-03*G0_0_0_1 + 8.333333333333307e-03*G0_0_1_1 + 8.333333333333311e-03*G0_0_2_1 + 1.666666666666662e-02*G0_0_3_1 + 8.333333333333305e-03*G0_1_4_1 + 8.333333333333311e-03*G0_1_5_1 + 8.333333333333314e-03*G0_1_6_1 + 1.666666666666662e-02*G0_1_7_1 + 8.333333333333305e-03*G0_2_8_1 + 8.333333333333311e-03*G0_2_9_1 + 8.333333333333312e-03*G0_2_10_1 + 1.666666666666662e-02*G0_2_11_1;
    block[39] = 8.333333333333311e-03*G0_0_0_2 + 8.333333333333307e-03*G0_0_1_2 + 8.333333333333311e-03*G0_0_2_2 + 1.666666666666662e-02*G0_0_3_2 + 8.333333333333305e-03*G0_1_4_2 + 8.333333333333311e-03*G0_1_5_2 + 8.333333333333314e-03*G0_1_6_2 + 1.666666666666662e-02*G0_1_7_2 + 8.333333333333305e-03*G0_2_8_2 + 8.333333333333311e-03*G0_2_9_2 + 8.333333333333312e-03*G0_2_10_2 + 1.666666666666662e-02*G0_2_11_2;
    block[40] = 0.000000000000000e+00;
    block[41] = 0.000000000000000e+00;
    block[42] = 0.000000000000000e+00;
    block[43] = 0.000000000000000e+00;
    block[44] = 0.000000000000000e+00;
    block[45] = 0.000000000000000e+00;
    block[46] = 0.000000000000000e+00;
    block[47] = 0.000000000000000e+00;
    block[48] = 0.000000000000000e+00;
    block[49] = 0.000000000000000e+00;
    block[50] = 0.000000000000000e+00;
    block[51] = 0.000000000000000e+00;
    block[52] = -1.666666666666662e-02*G0_0_0_0 - 1.666666666666662e-02*G0_0_0_1 - 1.666666666666662e-02*G0_0_0_2 - 8.333333333333305e-03*G0_0_1_0 - 8.333333333333305e-03*G0_0_1_1 - 8.333333333333305e-03*G0_0_1_2 - 8.333333333333305e-03*G0_0_2_0 - 8.333333333333305e-03*G0_0_2_1 - 8.333333333333305e-03*G0_0_2_2 - 8.333333333333305e-03*G0_0_3_0 - 8.333333333333305e-03*G0_0_3_1 - 8.333333333333305e-03*G0_0_3_2 - 1.666666666666661e-02*G0_1_4_0 - 1.666666666666661e-02*G0_1_4_1 - 1.666666666666661e-02*G0_1_4_2 - 8.333333333333307e-03*G0_1_5_0 - 8.333333333333307e-03*G0_1_5_1 - 8.333333333333305e-03*G0_1_5_2 - 8.333333333333307e-03*G0_1_6_0 - 8.333333333333307e-03*G0_1_6_1 - 8.333333333333307e-03*G0_1_6_2 - 8.333333333333305e-03*G0_1_7_0 - 8.333333333333305e-03*G0_1_7_1 - 8.333333333333305e-03*G0_1_7_2 - 1.666666666666661e-02*G0_2_8_0 - 1.666666666666661e-02*G0_2_8_1 - 1.666666666666661e-02*G0_2_8_2 - 8.333333333333307e-03*G0_2_9_0 - 8.333333333333307e-03*G0_2_9_1 - 8.333333333333305e-03*G0_2_9_2 - 8.333333333333307e-03*G0_2_10_0 - 8.333333333333307e-03*G0_2_10_1 - 8.333333333333307e-03*G0_2_10_2 - 8.333333333333305e-03*G0_2_11_0 - 8.333333333333305e-03*G0_2_11_1 - 8.333333333333305e-03*G0_2_11_2;
    block[53] = 1.666666666666662e-02*G0_0_0_0 + 8.333333333333305e-03*G0_0_1_0 + 8.333333333333305e-03*G0_0_2_0 + 8.333333333333305e-03*G0_0_3_0 + 1.666666666666661e-02*G0_1_4_0 + 8.333333333333307e-03*G0_1_5_0 + 8.333333333333307e-03*G0_1_6_0 + 8.333333333333305e-03*G0_1_7_0 + 1.666666666666661e-02*G0_2_8_0 + 8.333333333333307e-03*G0_2_9_0 + 8.333333333333307e-03*G0_2_10_0 + 8.333333333333305e-03*G0_2_11_0;
    block[54] = 1.666666666666662e-02*G0_0_0_1 + 8.333333333333305e-03*G0_0_1_1 + 8.333333333333305e-03*G0_0_2_1 + 8.333333333333305e-03*G0_0_3_1 + 1.666666666666661e-02*G0_1_4_1 + 8.333333333333307e-03*G0_1_5_1 + 8.333333333333307e-03*G0_1_6_1 + 8.333333333333305e-03*G0_1_7_1 + 1.666666666666661e-02*G0_2_8_1 + 8.333333333333307e-03*G0_2_9_1 + 8.333333333333307e-03*G0_2_10_1 + 8.333333333333305e-03*G0_2_11_1;
    block[55] = 1.666666666666662e-02*G0_0_0_2 + 8.333333333333305e-03*G0_0_1_2 + 8.333333333333305e-03*G0_0_2_2 + 8.333333333333305e-03*G0_0_3_2 + 1.666666666666661e-02*G0_1_4_2 + 8.333333333333307e-03*G0_1_5_2 + 8.333333333333307e-03*G0_1_6_2 + 8.333333333333305e-03*G0_1_7_2 + 1.666666666666661e-02*G0_2_8_2 + 8.333333333333307e-03*G0_2_9_2 + 8.333333333333307e-03*G0_2_10_2 + 8.333333333333305e-03*G0_2_11_2;
    block[56] = 0.000000000000000e+00;
    block[57] = 0.000000000000000e+00;
    block[58] = 0.000000000000000e+00;
    block[59] = 0.000000000000000e+00;
    block[60] = 0.000000000000000e+00;
    block[61] = 0.000000000000000e+00;
    block[62] = 0.000000000000000e+00;
    block[63] = 0.000000000000000e+00;
    block[64] = -8.333333333333309e-03*G0_0_0_0 - 8.333333333333309e-03*G0_0_0_1 - 8.333333333333309e-03*G0_0_0_2 - 1.666666666666661e-02*G0_0_1_0 - 1.666666666666661e-02*G0_0_1_1 - 1.666666666666661e-02*G0_0_1_2 - 8.333333333333309e-03*G0_0_2_0 - 8.333333333333309e-03*G0_0_2_1 - 8.333333333333309e-03*G0_0_2_2 - 8.333333333333311e-03*G0_0_3_0 - 8.333333333333311e-03*G0_0_3_1 - 8.333333333333311e-03*G0_0_3_2 - 8.333333333333307e-03*G0_1_4_0 - 8.333333333333307e-03*G0_1_4_1 - 8.333333333333305e-03*G0_1_4_2 - 1.666666666666662e-02*G0_1_5_0 - 1.666666666666662e-02*G0_1_5_1 - 1.666666666666661e-02*G0_1_5_2 - 8.333333333333311e-03*G0_1_6_0 - 8.333333333333311e-03*G0_1_6_1 - 8.333333333333311e-03*G0_1_6_2 - 8.333333333333311e-03*G0_1_7_0 - 8.333333333333311e-03*G0_1_7_1 - 8.333333333333311e-03*G0_1_7_2 - 8.333333333333307e-03*G0_2_8_0 - 8.333333333333307e-03*G0_2_8_1 - 8.333333333333305e-03*G0_2_8_2 - 1.666666666666662e-02*G0_2_9_0 - 1.666666666666662e-02*G0_2_9_1 - 1.666666666666661e-02*G0_2_9_2 - 8.333333333333311e-03*G0_2_10_0 - 8.333333333333311e-03*G0_2_10_1 - 8.333333333333311e-03*G0_2_10_2 - 8.333333333333311e-03*G0_2_11_0 - 8.333333333333311e-03*G0_2_11_1 - 8.333333333333311e-03*G0_2_11_2;
    block[65] = 8.333333333333309e-03*G0_0_0_0 + 1.666666666666661e-02*G0_0_1_0 + 8.333333333333309e-03*G0_0_2_0 + 8.333333333333311e-03*G0_0_3_0 + 8.333333333333307e-03*G0_1_4_0 + 1.666666666666662e-02*G0_1_5_0 + 8.333333333333311e-03*G0_1_6_0 + 8.333333333333311e-03*G0_1_7_0 + 8.333333333333307e-03*G0_2_8_0 + 1.666666666666662e-02*G0_2_9_0 + 8.333333333333311e-03*G0_2_10_0 + 8.333333333333311e-03*G0_2_11_0;
    block[66] = 8.333333333333309e-03*G0_0_0_1 + 1.666666666666661e-02*G0_0_1_1 + 8.333333333333309e-03*G0_0_2_1 + 8.333333333333311e-03*G0_0_3_1 + 8.333333333333307e-03*G0_1_4_1 + 1.666666666666662e-02*G0_1_5_1 + 8.333333333333311e-03*G0_1_6_1 + 8.333333333333311e-03*G0_1_7_1 + 8.333333333333307e-03*G0_2_8_1 + 1.666666666666662e-02*G0_2_9_1 + 8.333333333333311e-03*G0_2_10_1 + 8.333333333333311e-03*G0_2_11_1;
    block[67] = 8.333333333333309e-03*G0_0_0_2 + 1.666666666666661e-02*G0_0_1_2 + 8.333333333333309e-03*G0_0_2_2 + 8.333333333333311e-03*G0_0_3_2 + 8.333333333333307e-03*G0_1_4_2 + 1.666666666666662e-02*G0_1_5_2 + 8.333333333333311e-03*G0_1_6_2 + 8.333333333333311e-03*G0_1_7_2 + 8.333333333333307e-03*G0_2_8_2 + 1.666666666666662e-02*G0_2_9_2 + 8.333333333333311e-03*G0_2_10_2 + 8.333333333333311e-03*G0_2_11_2;
    block[68] = 0.000000000000000e+00;
    block[69] = 0.000000000000000e+00;
    block[70] = 0.000000000000000e+00;
    block[71] = 0.000000000000000e+00;
    block[72] = 0.000000000000000e+00;
    block[73] = 0.000000000000000e+00;
    block[74] = 0.000000000000000e+00;
    block[75] = 0.000000000000000e+00;
    block[76] = -8.333333333333312e-03*G0_0_0_0 - 8.333333333333312e-03*G0_0_0_1 - 8.333333333333312e-03*G0_0_0_2 - 8.333333333333311e-03*G0_0_1_0 - 8.333333333333311e-03*G0_0_1_1 - 8.333333333333309e-03*G0_0_1_2 - 1.666666666666662e-02*G0_0_2_0 - 1.666666666666662e-02*G0_0_2_1 - 1.666666666666662e-02*G0_0_2_2 - 8.333333333333314e-03*G0_0_3_0 - 8.333333333333314e-03*G0_0_3_1 - 8.333333333333314e-03*G0_0_3_2 - 8.333333333333307e-03*G0_1_4_0 - 8.333333333333307e-03*G0_1_4_1 - 8.333333333333307e-03*G0_1_4_2 - 8.333333333333311e-03*G0_1_5_0 - 8.333333333333311e-03*G0_1_5_1 - 8.333333333333311e-03*G0_1_5_2 - 1.666666666666662e-02*G0_1_6_0 - 1.666666666666662e-02*G0_1_6_1 - 1.666666666666662e-02*G0_1_6_2 - 8.333333333333314e-03*G0_1_7_0 - 8.333333333333314e-03*G0_1_7_1 - 8.333333333333314e-03*G0_1_7_2 - 8.333333333333307e-03*G0_2_8_0 - 8.333333333333307e-03*G0_2_8_1 - 8.333333333333307e-03*G0_2_8_2 - 8.333333333333311e-03*G0_2_9_0 - 8.333333333333311e-03*G0_2_9_1 - 8.333333333333311e-03*G0_2_9_2 - 1.666666666666662e-02*G0_2_10_0 - 1.666666666666662e-02*G0_2_10_1 - 1.666666666666662e-02*G0_2_10_2 - 8.333333333333314e-03*G0_2_11_0 - 8.333333333333314e-03*G0_2_11_1 - 8.333333333333314e-03*G0_2_11_2;
    block[77] = 8.333333333333312e-03*G0_0_0_0 + 8.333333333333311e-03*G0_0_1_0 + 1.666666666666662e-02*G0_0_2_0 + 8.333333333333314e-03*G0_0_3_0 + 8.333333333333307e-03*G0_1_4_0 + 8.333333333333311e-03*G0_1_5_0 + 1.666666666666662e-02*G0_1_6_0 + 8.333333333333314e-03*G0_1_7_0 + 8.333333333333307e-03*G0_2_8_0 + 8.333333333333311e-03*G0_2_9_0 + 1.666666666666662e-02*G0_2_10_0 + 8.333333333333314e-03*G0_2_11_0;
    block[78] = 8.333333333333312e-03*G0_0_0_1 + 8.333333333333311e-03*G0_0_1_1 + 1.666666666666662e-02*G0_0_2_1 + 8.333333333333314e-03*G0_0_3_1 + 8.333333333333307e-03*G0_1_4_1 + 8.333333333333311e-03*G0_1_5_1 + 1.666666666666662e-02*G0_1_6_1 + 8.333333333333314e-03*G0_1_7_1 + 8.333333333333307e-03*G0_2_8_1 + 8.333333333333311e-03*G0_2_9_1 + 1.666666666666662e-02*G0_2_10_1 + 8.333333333333314e-03*G0_2_11_1;
    block[79] = 8.333333333333312e-03*G0_0_0_2 + 8.333333333333311e-03*G0_0_1_2 + 1.666666666666662e-02*G0_0_2_2 + 8.333333333333314e-03*G0_0_3_2 + 8.333333333333307e-03*G0_1_4_2 + 8.333333333333311e-03*G0_1_5_2 + 1.666666666666662e-02*G0_1_6_2 + 8.333333333333314e-03*G0_1_7_2 + 8.333333333333307e-03*G0_2_8_2 + 8.333333333333311e-03*G0_2_9_2 + 1.666666666666662e-02*G0_2_10_2 + 8.333333333333314e-03*G0_2_11_2;
    block[80] = 0.000000000000000e+00;
    block[81] = 0.000000000000000e+00;
    block[82] = 0.000000000000000e+00;
    block[83] = 0.000000000000000e+00;
    block[84] = 0.000000000000000e+00;
    block[85] = 0.000000000000000e+00;
    block[86] = 0.000000000000000e+00;
    block[87] = 0.000000000000000e+00;
    block[88] = -8.333333333333311e-03*G0_0_0_0 - 8.333333333333311e-03*G0_0_0_1 - 8.333333333333311e-03*G0_0_0_2 - 8.333333333333307e-03*G0_0_1_0 - 8.333333333333307e-03*G0_0_1_1 - 8.333333333333307e-03*G0_0_1_2 - 8.333333333333311e-03*G0_0_2_0 - 8.333333333333311e-03*G0_0_2_1 - 8.333333333333311e-03*G0_0_2_2 - 1.666666666666662e-02*G0_0_3_0 - 1.666666666666662e-02*G0_0_3_1 - 1.666666666666662e-02*G0_0_3_2 - 8.333333333333305e-03*G0_1_4_0 - 8.333333333333305e-03*G0_1_4_1 - 8.333333333333305e-03*G0_1_4_2 - 8.333333333333311e-03*G0_1_5_0 - 8.333333333333311e-03*G0_1_5_1 - 8.333333333333311e-03*G0_1_5_2 - 8.333333333333314e-03*G0_1_6_0 - 8.333333333333314e-03*G0_1_6_1 - 8.333333333333314e-03*G0_1_6_2 - 1.666666666666662e-02*G0_1_7_0 - 1.666666666666662e-02*G0_1_7_1 - 1.666666666666662e-02*G0_1_7_2 - 8.333333333333305e-03*G0_2_8_0 - 8.333333333333305e-03*G0_2_8_1 - 8.333333333333305e-03*G0_2_8_2 - 8.333333333333311e-03*G0_2_9_0 - 8.333333333333311e-03*G0_2_9_1 - 8.333333333333311e-03*G0_2_9_2 - 8.333333333333312e-03*G0_2_10_0 - 8.333333333333312e-03*G0_2_10_1 - 8.333333333333312e-03*G0_2_10_2 - 1.666666666666662e-02*G0_2_11_0 - 1.666666666666662e-02*G0_2_11_1 - 1.666666666666662e-02*G0_2_11_2;
    block[89] = 8.333333333333311e-03*G0_0_0_0 + 8.333333333333307e-03*G0_0_1_0 + 8.333333333333311e-03*G0_0_2_0 + 1.666666666666662e-02*G0_0_3_0 + 8.333333333333305e-03*G0_1_4_0 + 8.333333333333311e-03*G0_1_5_0 + 8.333333333333314e-03*G0_1_6_0 + 1.666666666666662e-02*G0_1_7_0 + 8.333333333333305e-03*G0_2_8_0 + 8.333333333333311e-03*G0_2_9_0 + 8.333333333333312e-03*G0_2_10_0 + 1.666666666666662e-02*G0_2_11_0;
    block[90] = 8.333333333333311e-03*G0_0_0_1 + 8.333333333333307e-03*G0_0_1_1 + 8.333333333333311e-03*G0_0_2_1 + 1.666666666666662e-02*G0_0_3_1 + 8.333333333333305e-03*G0_1_4_1 + 8.333333333333311e-03*G0_1_5_1 + 8.333333333333314e-03*G0_1_6_1 + 1.666666666666662e-02*G0_1_7_1 + 8.333333333333305e-03*G0_2_8_1 + 8.333333333333311e-03*G0_2_9_1 + 8.333333333333312e-03*G0_2_10_1 + 1.666666666666662e-02*G0_2_11_1;
    block[91] = 8.333333333333311e-03*G0_0_0_2 + 8.333333333333307e-03*G0_0_1_2 + 8.333333333333311e-03*G0_0_2_2 + 1.666666666666662e-02*G0_0_3_2 + 8.333333333333305e-03*G0_1_4_2 + 8.333333333333311e-03*G0_1_5_2 + 8.333333333333314e-03*G0_1_6_2 + 1.666666666666662e-02*G0_1_7_2 + 8.333333333333305e-03*G0_2_8_2 + 8.333333333333311e-03*G0_2_9_2 + 8.333333333333312e-03*G0_2_10_2 + 1.666666666666662e-02*G0_2_11_2;
    block[92] = 0.000000000000000e+00;
    block[93] = 0.000000000000000e+00;
    block[94] = 0.000000000000000e+00;
    block[95] = 0.000000000000000e+00;
    block[96] = 0.000000000000000e+00;
    block[97] = 0.000000000000000e+00;
    block[98] = 0.000000000000000e+00;
    block[99] = 0.000000000000000e+00;
    block[100] = 0.000000000000000e+00;
    block[101] = 0.000000000000000e+00;
    block[102] = 0.000000000000000e+00;
    block[103] = 0.000000000000000e+00;
    block[104] = -1.666666666666662e-02*G0_0_0_0 - 1.666666666666662e-02*G0_0_0_1 - 1.666666666666662e-02*G0_0_0_2 - 8.333333333333305e-03*G0_0_1_0 - 8.333333333333305e-03*G0_0_1_1 - 8.333333333333305e-03*G0_0_1_2 - 8.333333333333305e-03*G0_0_2_0 - 8.333333333333305e-03*G0_0_2_1 - 8.333333333333305e-03*G0_0_2_2 - 8.333333333333305e-03*G0_0_3_0 - 8.333333333333305e-03*G0_0_3_1 - 8.333333333333305e-03*G0_0_3_2 - 1.666666666666661e-02*G0_1_4_0 - 1.666666666666661e-02*G0_1_4_1 - 1.666666666666661e-02*G0_1_4_2 - 8.333333333333307e-03*G0_1_5_0 - 8.333333333333307e-03*G0_1_5_1 - 8.333333333333305e-03*G0_1_5_2 - 8.333333333333307e-03*G0_1_6_0 - 8.333333333333307e-03*G0_1_6_1 - 8.333333333333307e-03*G0_1_6_2 - 8.333333333333305e-03*G0_1_7_0 - 8.333333333333305e-03*G0_1_7_1 - 8.333333333333305e-03*G0_1_7_2 - 1.666666666666661e-02*G0_2_8_0 - 1.666666666666661e-02*G0_2_8_1 - 1.666666666666661e-02*G0_2_8_2 - 8.333333333333307e-03*G0_2_9_0 - 8.333333333333307e-03*G0_2_9_1 - 8.333333333333305e-03*G0_2_9_2 - 8.333333333333307e-03*G0_2_10_0 - 8.333333333333307e-03*G0_2_10_1 - 8.333333333333307e-03*G0_2_10_2 - 8.333333333333305e-03*G0_2_11_0 - 8.333333333333305e-03*G0_2_11_1 - 8.333333333333305e-03*G0_2_11_2;
    block[105] = 1.666666666666662e-02*G0_0_0_0 + 8.333333333333305e-03*G0_0_1_0 + 8.333333333333305e-03*G0_0_2_0 + 8.333333333333305e-03*G0_0_3_0 + 1.666666666666661e-02*G0_1_4_0 + 8.333333333333307e-03*G0_1_5_0 + 8.333333333333307e-03*G0_1_6_0 + 8.333333333333305e-03*G0_1_7_0 + 1.666666666666661e-02*G0_2_8_0 + 8.333333333333307e-03*G0_2_9_0 + 8.333333333333307e-03*G0_2_10_0 + 8.333333333333305e-03*G0_2_11_0;
    block[106] = 1.666666666666662e-02*G0_0_0_1 + 8.333333333333305e-03*G0_0_1_1 + 8.333333333333305e-03*G0_0_2_1 + 8.333333333333305e-03*G0_0_3_1 + 1.666666666666661e-02*G0_1_4_1 + 8.333333333333307e-03*G0_1_5_1 + 8.333333333333307e-03*G0_1_6_1 + 8.333333333333305e-03*G0_1_7_1 + 1.666666666666661e-02*G0_2_8_1 + 8.333333333333307e-03*G0_2_9_1 + 8.333333333333307e-03*G0_2_10_1 + 8.333333333333305e-03*G0_2_11_1;
    block[107] = 1.666666666666662e-02*G0_0_0_2 + 8.333333333333305e-03*G0_0_1_2 + 8.333333333333305e-03*G0_0_2_2 + 8.333333333333305e-03*G0_0_3_2 + 1.666666666666661e-02*G0_1_4_2 + 8.333333333333307e-03*G0_1_5_2 + 8.333333333333307e-03*G0_1_6_2 + 8.333333333333305e-03*G0_1_7_2 + 1.666666666666661e-02*G0_2_8_2 + 8.333333333333307e-03*G0_2_9_2 + 8.333333333333307e-03*G0_2_10_2 + 8.333333333333305e-03*G0_2_11_2;
    block[108] = 0.000000000000000e+00;
    block[109] = 0.000000000000000e+00;
    block[110] = 0.000000000000000e+00;
    block[111] = 0.000000000000000e+00;
    block[112] = 0.000000000000000e+00;
    block[113] = 0.000000000000000e+00;
    block[114] = 0.000000000000000e+00;
    block[115] = 0.000000000000000e+00;
    block[116] = -8.333333333333309e-03*G0_0_0_0 - 8.333333333333309e-03*G0_0_0_1 - 8.333333333333309e-03*G0_0_0_2 - 1.666666666666661e-02*G0_0_1_0 - 1.666666666666661e-02*G0_0_1_1 - 1.666666666666661e-02*G0_0_1_2 - 8.333333333333309e-03*G0_0_2_0 - 8.333333333333309e-03*G0_0_2_1 - 8.333333333333309e-03*G0_0_2_2 - 8.333333333333311e-03*G0_0_3_0 - 8.333333333333311e-03*G0_0_3_1 - 8.333333333333311e-03*G0_0_3_2 - 8.333333333333307e-03*G0_1_4_0 - 8.333333333333307e-03*G0_1_4_1 - 8.333333333333305e-03*G0_1_4_2 - 1.666666666666662e-02*G0_1_5_0 - 1.666666666666662e-02*G0_1_5_1 - 1.666666666666661e-02*G0_1_5_2 - 8.333333333333311e-03*G0_1_6_0 - 8.333333333333311e-03*G0_1_6_1 - 8.333333333333311e-03*G0_1_6_2 - 8.333333333333311e-03*G0_1_7_0 - 8.333333333333311e-03*G0_1_7_1 - 8.333333333333311e-03*G0_1_7_2 - 8.333333333333307e-03*G0_2_8_0 - 8.333333333333307e-03*G0_2_8_1 - 8.333333333333305e-03*G0_2_8_2 - 1.666666666666662e-02*G0_2_9_0 - 1.666666666666662e-02*G0_2_9_1 - 1.666666666666661e-02*G0_2_9_2 - 8.333333333333311e-03*G0_2_10_0 - 8.333333333333311e-03*G0_2_10_1 - 8.333333333333311e-03*G0_2_10_2 - 8.333333333333311e-03*G0_2_11_0 - 8.333333333333311e-03*G0_2_11_1 - 8.333333333333311e-03*G0_2_11_2;
    block[117] = 8.333333333333309e-03*G0_0_0_0 + 1.666666666666661e-02*G0_0_1_0 + 8.333333333333309e-03*G0_0_2_0 + 8.333333333333311e-03*G0_0_3_0 + 8.333333333333307e-03*G0_1_4_0 + 1.666666666666662e-02*G0_1_5_0 + 8.333333333333311e-03*G0_1_6_0 + 8.333333333333311e-03*G0_1_7_0 + 8.333333333333307e-03*G0_2_8_0 + 1.666666666666662e-02*G0_2_9_0 + 8.333333333333311e-03*G0_2_10_0 + 8.333333333333311e-03*G0_2_11_0;
    block[118] = 8.333333333333309e-03*G0_0_0_1 + 1.666666666666661e-02*G0_0_1_1 + 8.333333333333309e-03*G0_0_2_1 + 8.333333333333311e-03*G0_0_3_1 + 8.333333333333307e-03*G0_1_4_1 + 1.666666666666662e-02*G0_1_5_1 + 8.333333333333311e-03*G0_1_6_1 + 8.333333333333311e-03*G0_1_7_1 + 8.333333333333307e-03*G0_2_8_1 + 1.666666666666662e-02*G0_2_9_1 + 8.333333333333311e-03*G0_2_10_1 + 8.333333333333311e-03*G0_2_11_1;
    block[119] = 8.333333333333309e-03*G0_0_0_2 + 1.666666666666661e-02*G0_0_1_2 + 8.333333333333309e-03*G0_0_2_2 + 8.333333333333311e-03*G0_0_3_2 + 8.333333333333307e-03*G0_1_4_2 + 1.666666666666662e-02*G0_1_5_2 + 8.333333333333311e-03*G0_1_6_2 + 8.333333333333311e-03*G0_1_7_2 + 8.333333333333307e-03*G0_2_8_2 + 1.666666666666662e-02*G0_2_9_2 + 8.333333333333311e-03*G0_2_10_2 + 8.333333333333311e-03*G0_2_11_2;
    block[120] = 0.000000000000000e+00;
    block[121] = 0.000000000000000e+00;
    block[122] = 0.000000000000000e+00;
    block[123] = 0.000000000000000e+00;
    block[124] = 0.000000000000000e+00;
    block[125] = 0.000000000000000e+00;
    block[126] = 0.000000000000000e+00;
    block[127] = 0.000000000000000e+00;
    block[128] = -8.333333333333312e-03*G0_0_0_0 - 8.333333333333312e-03*G0_0_0_1 - 8.333333333333312e-03*G0_0_0_2 - 8.333333333333311e-03*G0_0_1_0 - 8.333333333333311e-03*G0_0_1_1 - 8.333333333333309e-03*G0_0_1_2 - 1.666666666666662e-02*G0_0_2_0 - 1.666666666666662e-02*G0_0_2_1 - 1.666666666666662e-02*G0_0_2_2 - 8.333333333333312e-03*G0_0_3_0 - 8.333333333333312e-03*G0_0_3_1 - 8.333333333333312e-03*G0_0_3_2 - 8.333333333333307e-03*G0_1_4_0 - 8.333333333333307e-03*G0_1_4_1 - 8.333333333333307e-03*G0_1_4_2 - 8.333333333333311e-03*G0_1_5_0 - 8.333333333333311e-03*G0_1_5_1 - 8.333333333333311e-03*G0_1_5_2 - 1.666666666666662e-02*G0_1_6_0 - 1.666666666666662e-02*G0_1_6_1 - 1.666666666666662e-02*G0_1_6_2 - 8.333333333333312e-03*G0_1_7_0 - 8.333333333333312e-03*G0_1_7_1 - 8.333333333333312e-03*G0_1_7_2 - 8.333333333333307e-03*G0_2_8_0 - 8.333333333333307e-03*G0_2_8_1 - 8.333333333333307e-03*G0_2_8_2 - 8.333333333333311e-03*G0_2_9_0 - 8.333333333333311e-03*G0_2_9_1 - 8.333333333333311e-03*G0_2_9_2 - 1.666666666666662e-02*G0_2_10_0 - 1.666666666666662e-02*G0_2_10_1 - 1.666666666666662e-02*G0_2_10_2 - 8.333333333333312e-03*G0_2_11_0 - 8.333333333333312e-03*G0_2_11_1 - 8.333333333333312e-03*G0_2_11_2;
    block[129] = 8.333333333333312e-03*G0_0_0_0 + 8.333333333333311e-03*G0_0_1_0 + 1.666666666666662e-02*G0_0_2_0 + 8.333333333333312e-03*G0_0_3_0 + 8.333333333333307e-03*G0_1_4_0 + 8.333333333333311e-03*G0_1_5_0 + 1.666666666666662e-02*G0_1_6_0 + 8.333333333333312e-03*G0_1_7_0 + 8.333333333333307e-03*G0_2_8_0 + 8.333333333333311e-03*G0_2_9_0 + 1.666666666666662e-02*G0_2_10_0 + 8.333333333333312e-03*G0_2_11_0;
    block[130] = 8.333333333333312e-03*G0_0_0_1 + 8.333333333333311e-03*G0_0_1_1 + 1.666666666666662e-02*G0_0_2_1 + 8.333333333333312e-03*G0_0_3_1 + 8.333333333333307e-03*G0_1_4_1 + 8.333333333333311e-03*G0_1_5_1 + 1.666666666666662e-02*G0_1_6_1 + 8.333333333333312e-03*G0_1_7_1 + 8.333333333333307e-03*G0_2_8_1 + 8.333333333333311e-03*G0_2_9_1 + 1.666666666666662e-02*G0_2_10_1 + 8.333333333333312e-03*G0_2_11_1;
    block[131] = 8.333333333333312e-03*G0_0_0_2 + 8.333333333333311e-03*G0_0_1_2 + 1.666666666666662e-02*G0_0_2_2 + 8.333333333333312e-03*G0_0_3_2 + 8.333333333333307e-03*G0_1_4_2 + 8.333333333333311e-03*G0_1_5_2 + 1.666666666666662e-02*G0_1_6_2 + 8.333333333333312e-03*G0_1_7_2 + 8.333333333333307e-03*G0_2_8_2 + 8.333333333333311e-03*G0_2_9_2 + 1.666666666666662e-02*G0_2_10_2 + 8.333333333333312e-03*G0_2_11_2;
    block[132] = 0.000000000000000e+00;
    block[133] = 0.000000000000000e+00;
    block[134] = 0.000000000000000e+00;
    block[135] = 0.000000000000000e+00;
    block[136] = 0.000000000000000e+00;
    block[137] = 0.000000000000000e+00;
    block[138] = 0.000000000000000e+00;
    block[139] = 0.000000000000000e+00;
    block[140] = -8.333333333333311e-03*G0_0_0_0 - 8.333333333333311e-03*G0_0_0_1 - 8.333333333333311e-03*G0_0_0_2 - 8.333333333333307e-03*G0_0_1_0 - 8.333333333333307e-03*G0_0_1_1 - 8.333333333333307e-03*G0_0_1_2 - 8.333333333333311e-03*G0_0_2_0 - 8.333333333333311e-03*G0_0_2_1 - 8.333333333333311e-03*G0_0_2_2 - 1.666666666666662e-02*G0_0_3_0 - 1.666666666666662e-02*G0_0_3_1 - 1.666666666666662e-02*G0_0_3_2 - 8.333333333333305e-03*G0_1_4_0 - 8.333333333333305e-03*G0_1_4_1 - 8.333333333333305e-03*G0_1_4_2 - 8.333333333333311e-03*G0_1_5_0 - 8.333333333333311e-03*G0_1_5_1 - 8.333333333333311e-03*G0_1_5_2 - 8.333333333333314e-03*G0_1_6_0 - 8.333333333333314e-03*G0_1_6_1 - 8.333333333333314e-03*G0_1_6_2 - 1.666666666666662e-02*G0_1_7_0 - 1.666666666666662e-02*G0_1_7_1 - 1.666666666666662e-02*G0_1_7_2 - 8.333333333333305e-03*G0_2_8_0 - 8.333333333333305e-03*G0_2_8_1 - 8.333333333333305e-03*G0_2_8_2 - 8.333333333333311e-03*G0_2_9_0 - 8.333333333333311e-03*G0_2_9_1 - 8.333333333333311e-03*G0_2_9_2 - 8.333333333333312e-03*G0_2_10_0 - 8.333333333333312e-03*G0_2_10_1 - 8.333333333333312e-03*G0_2_10_2 - 1.666666666666662e-02*G0_2_11_0 - 1.666666666666662e-02*G0_2_11_1 - 1.666666666666662e-02*G0_2_11_2;
    block[141] = 8.333333333333311e-03*G0_0_0_0 + 8.333333333333307e-03*G0_0_1_0 + 8.333333333333311e-03*G0_0_2_0 + 1.666666666666662e-02*G0_0_3_0 + 8.333333333333305e-03*G0_1_4_0 + 8.333333333333311e-03*G0_1_5_0 + 8.333333333333314e-03*G0_1_6_0 + 1.666666666666662e-02*G0_1_7_0 + 8.333333333333305e-03*G0_2_8_0 + 8.333333333333311e-03*G0_2_9_0 + 8.333333333333312e-03*G0_2_10_0 + 1.666666666666662e-02*G0_2_11_0;
    block[142] = 8.333333333333311e-03*G0_0_0_1 + 8.333333333333307e-03*G0_0_1_1 + 8.333333333333311e-03*G0_0_2_1 + 1.666666666666662e-02*G0_0_3_1 + 8.333333333333305e-03*G0_1_4_1 + 8.333333333333311e-03*G0_1_5_1 + 8.333333333333314e-03*G0_1_6_1 + 1.666666666666662e-02*G0_1_7_1 + 8.333333333333305e-03*G0_2_8_1 + 8.333333333333311e-03*G0_2_9_1 + 8.333333333333312e-03*G0_2_10_1 + 1.666666666666662e-02*G0_2_11_1;
    block[143] = 8.333333333333311e-03*G0_0_0_2 + 8.333333333333307e-03*G0_0_1_2 + 8.333333333333311e-03*G0_0_2_2 + 1.666666666666662e-02*G0_0_3_2 + 8.333333333333305e-03*G0_1_4_2 + 8.333333333333311e-03*G0_1_5_2 + 8.333333333333314e-03*G0_1_6_2 + 1.666666666666662e-02*G0_1_7_2 + 8.333333333333305e-03*G0_2_8_2 + 8.333333333333311e-03*G0_2_9_2 + 8.333333333333312e-03*G0_2_10_2 + 1.666666666666662e-02*G0_2_11_2;

  }

};

} }

#endif
