import sys
sys.path.append("../")
sys.path.append("../../")
from ffc.compiler.compiler import *

name = "PoissonSystem"

a = None
L = None
    
dx = Integral("interior")
ds = Integral("boundary")

i = Index()
j = Index()
k = Index()
l = Index()
m = Index()
n = Index()

# Copyright (c) 2005 Anders Logg (logg@tti-c.org)
# Licensed under the GNU GPL Version 2
#
# The bilinear form a(u,v) and linear form L(v) for
# Poisson's equation in system form (vector-valued).
#
# Compile this form with FFC: ffc PoissonSystem.form

element = FiniteElement("Vector Lagrange", "triangle", 1)

v = BasisFunction(element)
u = BasisFunction(element)
f = Function(element)

a = u[i].dx(j)*v[i].dx(j)*dx
L = f[i]*v[i]*dx

compile([a, L], name, "0.1.8", "C++", "GNU GPL Version 2")
